Summary:        Read a preset list of files into memory.
Name:           readahead
Version:        1.2
Release:	2
Epoch:		1
Group:          System Environment/Base
License:        GPL/OSL
Source0:	readahead.c
Source1:	readahead.init
Source2:	readahead.files.in
Source3:	readahead_early.init
Source4:	readahead.early.files.in
Source5:	COPYING
Source6:	README
Buildroot:      %{_tmppath}/%{name}-%{version}-root
Prereq:		/sbin/chkconfig
Requires:	procps /bin/awk
BuildPreReq:	e2fsprogs-devel
BuildRequires:	pkgconfig
Obsoletes:	kernel-utils

%description
readahead reads the contents of a list of files into memory,
which causes them to be read from cache when they are actually
needed. Its goal is to speed up the boot process.

%prep
[ "%{_builddir}" != "%{_sourcedir}" ] && cp %{SOURCE5} %{SOURCE6} .

%build
rm -rf $RPM_BUILD_ROOT

mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}/etc/rc.d/init.d
mkdir -p %{buildroot}/etc/sysconfig
gcc $RPM_OPT_FLAGS %{SOURCE0} -o readahead `pkg-config --libs ext2fs blkid`

for file in %{SOURCE2} %{SOURCE4} ; do
  f=${file##*/}
  sed 's|%%{_lib}|%{_lib}|g; s|%%{_arch}|%{_arch}|g' $file > ${f%%.in}
done

%install
install %{SOURCE1} %{buildroot}/etc/rc.d/init.d/readahead
install readahead.files %{buildroot}/etc/readahead.files
install %{SOURCE3} %{buildroot}/etc/rc.d/init.d/readahead_early
install readahead.early.files %{buildroot}/etc/readahead.early.files
install -m 755 readahead %{buildroot}%{_sbindir}

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files
%defattr(-,root,root)
%doc COPYING README
%attr(0644,root,root) /etc/readahead.files
%attr(0644,root,root) /etc/readahead.early.files
%{_sbindir}/readahead
/etc/rc.d/init.d/readahead
/etc/rc.d/init.d/readahead_early

%preun
if [ "$1" = "0" ] ; then
 /sbin/chkconfig --del readahead
 /sbin/chkconfig --del readahead_early
fi

%post
/sbin/chkconfig --add readahead
/sbin/chkconfig --add readahead_early

%triggerpostun -- kernel-utils
/sbin/chkconfig --add readahead
/sbin/chkconfig --add readahead_early
exit 0


%changelog
* Wed Apr 05 2006 Eddy Nigg <eddy_nigg@startcom.org>
- Rebuild for StartCom Linux 5.0.x

* Mon Mar 20 2006 Karel Zak <kzak@redhat.com> 1.2-2
- cleanup release number
- cleanup spec file

* Thu Mar 16 2006 Karel Zak <kzak@redhat.com>
- update versions in *.in lists

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 1:1.2-1.24.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 1:1.2-1.23.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Jan 13 2006 Karel Zak <kzak@redhat.com>
- check & cleanup list of files by readahead-gen script

* Wed Dec 21 2005 Karel Zak <kzak@redhat.com>
- removed double slashes in the directory names
- removed or fixed the rest of X11R6 directories

* Mon Dec 19 2005 Karel Zak <kzak@redhat.com>
- sync versioned gcc, firefox, openoffice.org, evolution dirs with FC5

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Aug  4 2005 Dave Jones <davej@redhat.com>
- Integrated changes from Ville Skyttä (#164872)
  - Fix inverted logic in readahead_early also.
  - readahead_early looks useful in more runlevels than just 5.
  - Sync versioned gcc, firefox and openoffice.org dirs with FC4 updates.

* Tue Aug  2 2005 Dave Jones <davej@redhat.com>
- Fix inverted free memory test in startup script. (#164872)

* Wed May 18 2005 Bill Nottingham <notting@redhat.com>
- new readahead.c from Ziga Mahkovec <ziga.mahkovec@klika.si>
  - optimizes read access for more throughput
- regenerate file lists (#128444)
- fix lack of newlines (#146744)
- fix lists so that they are architecture-neutral
- move check for > 384MB into the init scripts, not the %%post

* Tue Mar  1 2005 Dave Jones <davej@redhat.com>
- Rebuild for gcc4

* Thu Feb 10 2005 Dave Jones <davej@redhat.com>
- Remove non-existent files from file lists.

* Fri Jan 14 2005 Dave Jones <davej@redhat.com>
- Don't do readahead if we have less than 256MB of memory.

* Sat Dec 18 2004 Dave Jones <davej@redhat.com>
- Initial packaging, based upon kernel-utils.

